SystemOrganization addCategory: #'Volunteer-Marketplace'!

Object subclass: #Skill
	instanceVariableNames: 'name description'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Volunteer-Marketplace'!

!Skill commentStamp: 'RG 9/19/2012 20:57' prior: 0!
Represent a skill of a volunteer or needed in a task.!

!Skill methodsFor: 'comparing' stamp: 'RG 9/19/2012 22:00'!
= aSkill
	"Testing Equality"
	^ (self name) = (aSkill name).! !

!Skill methodsFor: 'accessors' stamp: 'RG 9/19/2012 21:00'!
description
	"Getter of description"
	^description.! !

!Skill methodsFor: 'accessors' stamp: 'RG 9/19/2012 21:01'!
description: aDescription
	"Setter of description"
	description := aDescription.! !

!Skill methodsFor: 'initialize-release' stamp: 'RG 9/19/2012 21:04'!
initialize
	"Empty constructor"
	super initialize.
	self name: ''.
	self description: ''.! !

!Skill methodsFor: 'initialize-release' stamp: 'RG 9/19/2012 21:06'!
initialize: aName desc: aDescription
	"Constructor with parameters"
	self name: aName.
	self description: aDescription.! !

!Skill methodsFor: 'accessors' stamp: 'RG 9/19/2012 20:58'!
name
	"Getter of a name"
	^name.! !

!Skill methodsFor: 'accessors' stamp: 'RG 9/19/2012 20:59'!
name: aName
	"Setter of name"
	name := aName.! !

Object subclass: #Task
	instanceVariableNames: 'name skills volunteers description state estimatedTime startDate endDate'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Volunteer-Marketplace'!

!Task commentStamp: 'RG 9/19/2012 22:28' prior: 0!
Represents a project task.!

!Task methodsFor: 'as yet unclassified' stamp: 'RG 9/19/2012 22:38'!
addSkill: aSkill
	"Add a needed skill to the task"
	[ self hasSkill: aSkill ] ifFalse: [ skills add: aSkill. ].! !

!Task methodsFor: 'as yet unclassified' stamp: 'RG 9/19/2012 22:39'!
addVolunteer: aVolunteer
	"Adds a volunteer to perform the task"
	volunteers add: aVolunteer.! !

!Task methodsFor: 'as yet unclassified' stamp: 'RG 9/19/2012 22:37'!
hasSkill: aSkill
	"Test if contains a skill"
	^ skills includes: aSkill.! !

!Task methodsFor: 'initialize-release' stamp: 'RG 9/19/2012 22:34'!
initialize
	"Constructor"
	skills := OrderedCollection new.
	volunteers := OrderedCollection new.
	startDate := Date new.
	endDate := Date new.
	description := ''.
	name := ''.
	state := ''.
	estimatedTime := 0.! !

Object subclass: #Volunteer
	instanceVariableNames: 'skills disponibility availability workTime finishedTasks finishedProjects birthday'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Volunteer-Marketplace'!

!Volunteer commentStamp: 'RG 9/19/2012 21:15' prior: 0!
Represents a volunteer.!

!Volunteer methodsFor: 'as yet unclassified' stamp: 'RG 9/19/2012 21:30'!
addSkill: aSkill
	"Add a skill to the volunteer"
	skills add: aSkill.! !

!Volunteer methodsFor: 'accessors' stamp: 'RG 9/19/2012 21:41'!
availability
	"Getter availability"
	^availability.! !

!Volunteer methodsFor: 'accessors' stamp: 'RG 9/19/2012 21:43'!
availability: anAvailability
	"Setter of availability"
	availability := anAvailability.! !

!Volunteer methodsFor: 'accessors' stamp: 'RG 9/19/2012 21:37'!
birthday
	"Getter of birthday"
	^birthday.! !

!Volunteer methodsFor: 'accessors' stamp: 'RG 9/19/2012 21:38'!
birthday: aBirthday
	"Setter of Birthday"
	birthday := aBirthday.! !

!Volunteer methodsFor: 'accessors' stamp: 'RG 9/19/2012 21:39'!
disponibility
	"Getter of disponibility"
	^disponibility.! !

!Volunteer methodsFor: 'accessors' stamp: 'RG 9/19/2012 21:41'!
disponibility: aDisponibility
	"Setter of disponibility"
	disponibility := aDisponibility.! !

!Volunteer methodsFor: 'accessors' stamp: 'RG 9/19/2012 21:46'!
finishedProjects
	"Getter finishedProjects"
	^finishedProjects.! !

!Volunteer methodsFor: 'accessors' stamp: 'RG 9/19/2012 21:47'!
finishedProjects: numberFinished
	"Setter finishedPrijects"
	finishedProjects := numberFinished.! !

!Volunteer methodsFor: 'accessors' stamp: 'RG 9/19/2012 21:49'!
finishedTasks
	"Getter finishedTasks"
.	^finishedTasks.! !

!Volunteer methodsFor: 'accessors' stamp: 'RG 9/19/2012 21:49'!
finishedTasks: numberFinished
	"Setter finished Tasks"
	finishedTasks := numberFinished.! !

!Volunteer methodsFor: 'as yet unclassified' stamp: 'RG 9/19/2012 22:07'!
hasSkill: aSkill
	"Test if has an specific skill"
	^ skills includes: aSkill.! !

!Volunteer methodsFor: 'initialize-release' stamp: 'RG 9/19/2012 22:06'!
initialize
	"Constructor"
	skills := OrderedCollection new.
	disponibility := ''.
	availability := false.
	workTime := ''.
	finishedTasks := 0.
	finishedProjects := 0.
	birthday := Date new.
	! !

!Volunteer methodsFor: 'accessors' stamp: 'RG 9/19/2012 21:44'!
workTime
	"Getter of worktime"
	^workTime.! !

!Volunteer methodsFor: 'accessors' stamp: 'RG 9/19/2012 21:45'!
workTime: aWorkTime
	"comment stating purpose of message"
	workTime := aWorkTime.! !
